scala.tools.nsc.backend.jvm

# BTypes

###
Related Doc: package jvm

#### abstract class BTypes extends AnyRef

The BTypes component defines The BType class hierarchy. BTypes encapsulates all type information that is required after building the ASM nodes. This includes optimizations, geneartion of InnerClass attributes and generation of stack map frames.

This representation is immutable and independent of the compiler data structures, hence it can be queried by concurrent threads.

Source
  BTypes.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
BTypesFromSymbols
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BTypes
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BTypes()

### Type Members

1. #### case class ArrayBType(componentType: BType) extends RefBType with Product with Serializable

2. #### trait BType extends AnyRef

   A BType is either a primitve type, a ClassBType, an ArrayBType of one of these, or a MethodType referring to BTypes.

3. #### final class ClassBType extends RefBType

   A ClassBType represents a class or interface type.

   A ClassBType represents a class or interface type. The necessary information to build a ClassBType is extracted from compiler symbols and types, see BTypesFromSymbols.

   The `offset` and `length` fields are used to represent the internal name of the class. They are indices into some character array. The internal name can be obtained through the method `internalNameString`, which is abstract in this component. Name creation is assumed to be hash-consed, so if two ClassBTypes have the same internal name, they NEED to have the same `offset` and `length`.

   The actual implementation in subclass BTypesFromSymbols uses the global `chrs` array from the name table. This representation is efficient because the JVM class name is obtained through `classSymbol.javaBinaryName`. This already adds the necessary string to the `chrs` array, so it makes sense to reuse the same name table in the backend.

   ClassBType is not a case class because we want a custom equals method, and because the extractor extracts the internalName, which is what you typically need.

4. #### case class ClassInfo(superClass: Option[ClassBType], interfaces: List[ClassBType], flags: Int, memberClasses: List[ClassBType], nestedInfo: Option[NestedInfo]) extends Product with Serializable

   The type info for a class.

   The type info for a class. Used for symboltable-independent subtype checks in the backend.

   superClass

     The super class, not defined for class java/lang/Object.

   interfaces

     All transitively implemented interfaces, except for those inherited through the superclass.

   flags

     The java flags, obtained through `javaFlags`. Used also to derive the flags for InnerClass entries.

   memberClasses

     Classes nested in this class. Those need to be added to the InnerClass table, see the InnerClass spec summary above.

   nestedInfo

     If this describes a nested class, information for the InnerClass table.

5. #### case class InnerClassEntry(name: String, outerName: String, innerName: String, flags: Int) extends Product with Serializable

   This class holds the data for an entry in the InnerClass table.

   This class holds the data for an entry in the InnerClass table. See the InnerClass summary above in this file.

   There's some overlap with the class NestedInfo, but it's not exactly the same and cleaner to keep separate.

   name

     The internal name of the class.

   outerName

     The internal name of the outer class, may be null.

   innerName

     The simple name of the inner class, may be null.

   flags

     The flags for this class in the InnerClass entry.

6. #### case class MethodBType(argumentTypes: List[BType], returnType: BType) extends BType with Product with Serializable

7. #### final case class MethodNameAndType(name: String, methodType: MethodBType) extends Product with Serializable

   Just a named pair, used in CoreBTypes.asmBoxTo/asmUnboxTo.

8. #### case class NestedInfo(enclosingClass: ClassBType, outerName: Option[String], innerName: Option[String], isStaticNestedClass: Boolean) extends Product with Serializable

   Information required to add a class to an InnerClass table.

   Information required to add a class to an InnerClass table. The spec summary above explains what information is required for the InnerClass entry.

   enclosingClass

     The enclosing class, if it is also nested. When adding a class to the InnerClass table, enclosing nested classes are also added.

   outerName

     The outerName field in the InnerClass entry, may be None.

   innerName

     The innerName field, may be None.

   isStaticNestedClass

     True if this is a static nested class (not inner class) (*)

     (*) Note that the STATIC flag in ClassInfo.flags, obtained through javaFlags(classSym), is not correct for the InnerClass entry, see javaFlags. The static flag in the InnerClass describes a source-level propety: if the class is in a static context (does not have an outer pointer). This is checked when building the NestedInfo.

9. #### sealed trait PrimitiveBType extends BType

10. #### sealed trait RefBType extends BType

### Abstract Value Members

1. #### abstract val classBTypeFromInternalNameMap: Map[String, ClassBType]

   A map from internal names to ClassBTypes.

   A map from internal names to ClassBTypes. Every ClassBType is added to this map on its construction.

   This map is used when computing stack map frames. The asm.ClassWriter invokes the method `getCommonSuperClass`. In this method we need to obtain the ClassBType for a given internal name. The method assumes that every class type that appears in the bytecode exists in the map.

   Concurrent because stack map frames are computed when in the class writer, which might run on multiple classes concurrently.

   Attributes
     protected

2. #### abstract val coreBTypes: CoreBTypesProxyGlobalIndependent[BTypes.this.type]

3. #### abstract def internalNameString(offset: Int, lenght: Int): String

   The string represented by the `offset` / `length` values of a ClassBType, see comment of that class.

   The string represented by the `offset` / `length` values of a ClassBType, see comment of that class.

   Attributes
     protected

4. #### abstract def isCompilingPrimitive: Boolean

   True if the current compilation unit is of a primitive class (scala.Boolean et al).

   True if the current compilation unit is of a primitive class (scala.Boolean et al). Used only in assertions. Abstract here because its implementation depends on global.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BTypes to any2stringadd[BTypes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BTypes, B)

   Implicit information
     This member is added by an implicit conversion from BTypes to ArrowAssoc[BTypes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object BOOL extends PrimitiveBType with Product with Serializable

7. #### object BYTE extends PrimitiveBType with Product with Serializable

8. #### object CHAR extends PrimitiveBType with Product with Serializable

9. #### object ClassBType

10. #### object DOUBLE extends PrimitiveBType with Product with Serializable

11. #### object FLOAT extends PrimitiveBType with Product with Serializable

12. #### object INT extends PrimitiveBType with Product with Serializable

13. #### object LONG extends PrimitiveBType with Product with Serializable

14. #### object SHORT extends PrimitiveBType with Product with Serializable

15. #### object UNIT extends PrimitiveBType with Product with Serializable

16. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

17. #### def classBTypeFromInternalName(internalName: String): ClassBType

    Obtain a previously constructed ClassBType for a given internal name.

18. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

19. #### def ensuring(cond: (BTypes) ⇒ Boolean, msg: ⇒ Any): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: (BTypes) ⇒ Boolean): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean, msg: ⇒ Any): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### def ensuring(cond: Boolean): BTypes

    Implicit information
      This member is added by an implicit conversion from BTypes to Ensuring[BTypes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

23. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

24. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

25. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

26. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BTypes to StringFormat[BTypes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

28. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

29. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

30. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

32. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

34. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

35. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### def →[B](y: B): (BTypes, B)

    Implicit information
      This member is added by an implicit conversion from BTypes to ArrowAssoc[BTypes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BTypes to any2stringadd[BTypes]

### Inherited by implicit conversion StringFormat from BTypes to StringFormat[BTypes]

### Inherited by implicit conversion Ensuring from BTypes to Ensuring[BTypes]

### Inherited by implicit conversion ArrowAssoc from BTypes to ArrowAssoc[BTypes]

### Ungrouped